local Widgets = _Avyr_Global_ADDON_Elements_Lib:Initialize("AvyrRaidTools","Widgets")
local Loc = _Avyr_Global_ADDON_Elements_Lib:Initialize("AvyrRaidTools","Localisation")
local _ARTG = _Avyr_Raid_Tools_ADDON_Globals
local BorderSize, Padding = Widgets.BorderSize, Widgets.Padding;
local wipe, insert = table.wipe, table.insert

--Method Group
local Display = {}
_ARTG.HealerManaDisplay = Display

local HealerManaTable =  {}

local HealerManaDisplay

_ARTG.SV.RegisterSVCallback(function(varName,varValue)
	if varName == "ALL" or varName == "G_Enable" or varName == "HMD_Enable" or varName == "G_LoadConditions" or varName == "CurrentNote" then 
		_ARTG.HealerManaDisplay:Load()   
	end 

	if varName == "ALL" or varName == "HMD_Anchor" or varName == "HMD_AnchorPoint" or varName == "HMD_Locked" or varName == "HMD_MatchWidth" or 
	varName == "HMD_Scale" or varName == "HMD_PosX" or varName == "HMD_PosY" or varName == "HMD_Width" or varName == "HMD_BarHeight" or
	varName == "ND_Width" or varName == "ND_Height" or varName == "ND_PosX" or varName == "ND_PosY" or varName == "ND_Scale" or varName == "ND_Locked" then 
		_ARTG.HealerManaDisplay:UpdateDimensions()
	end 

	if varName == "ALL" or varName == "HMD_MatchBackdrop" or varName == "HMD_Backdrop" or varName == "HMD_Backdropr" or varName == "HMD_Backdropg" or 
	varName == "HMD_Backdropb" or varName == "HMD_Backdropa" or varName == "HMD_BarClassColor" or varName == "HMD_BarColorr" or varName == "HMD_BarColorg" or 
	varName == "HMD_BarColorb" or varName == "HMD_BarColora" or varName == "HMD_BarFontColorr" or varName == "HMD_BarFontColorg" or varName == "HMD_BarFontColorb" or 
	varName == "HMD_BarFontColora" then 
		_ARTG.HealerManaDisplay:UpdateColors()
	end

	if varName == "ALL" or varName == "HMD_IgnoreOwn" then 
		_ARTG.HealerManaDisplay:Refresh(UnitGUID("player"))
	end

	if varName == "ALL" or varName == "HMD_MatchZone" then 
		_ARTG.HealerManaDisplay:Refresh()
	end
end,"ALL","G_Enable","HMD_Enable",
	"G_LoadConditions","CurrentNote",
	"HMD_Anchor","HMD_AnchorPoint","HMD_Locked","HMD_MatchWidth",
	"HMD_Scale","HMD_PosX","HMD_PosY","HMD_Width","HMD_BarHeight",
	"HMD_MatchBackdrop","HMD_Backdrop","HMD_Backdropr","HMD_Backdropg","HMD_Backdropb","HMD_Backdropa",
	"HMD_BarClassColor","HMD_BarColorr","HMD_BarColorg","HMD_BarColorb","HMD_BarColora","HMD_BarFontColorr","HMD_BarFontColorg","HMD_BarFontColorb","HMD_BarFontColora",
	"HMD_IgnoreOwn","HMD_MatchZone",
	"ND_Width","ND_Height","ND_PosX","ND_PosY","ND_Scale", "ND_Locked"
)

--Methods
function Display:GetWindow()
	return HealerManaDisplay
end 

function Display:Load()
	if HealerManaDisplay then 
		HealerManaDisplay:Release()
		HealerManaDisplay = nil
	end 
	
	HealerManaDisplay = Widgets:CreateFrame(UIParent)   
	HealerManaDisplay:Size(160,20)
	HealerManaDisplay:SetPoint("CENTER")  
	HealerManaDisplay:SetClampedToScreen(true)
	HealerManaDisplay.OnMove = function(self)
		local _, parent, _, x, y = self:GetPoint(1)
		if parent == UIParent then 
			_ARTG.SV.SaveVariable("HMD_PosX", x*HealerManaDisplay:GetEffectiveScale(), true)
			_ARTG.SV.SaveVariable("HMD_PosY", y*HealerManaDisplay:GetEffectiveScale())	
		else 
			local a,b,c,d,e = parent:GetPoint(1)
			parent:ClearAllPoints()
			parent:SetPoint(a, b, c, d + x*HealerManaDisplay:GetEffectiveScale()/parent:GetEffectiveScale(), e + y*HealerManaDisplay:GetEffectiveScale()/parent:GetEffectiveScale())
			parent:OnMove()
		end 
	end
	Display:UpdateDimensions()
	Display:UpdateColors() 
	Display:Refresh()
	
	if _ARTG:CheckLoadConditions("HealerManaDisplay") then 
		HealerManaDisplay:Show()
	else 
		HealerManaDisplay:Hide()
	end
end 

function Display:UpdateDimensions()
		local WidthOverride = _ARTG:FrameAnchoring(HealerManaDisplay,_ARTG.SV.GetVariable("HMD_Anchor"),_ARTG.SV.GetVariable("HMD_AnchorPoint"),
			_ARTG.SV.GetVariable("HMD_Locked"),_ARTG.SV.GetVariable("HMD_MatchWidth"),_ARTG.SV.GetVariable("HMD_Scale"),
			_ARTG.SV.GetVariable("HMD_PosX"),_ARTG.SV.GetVariable("HMD_PosY")
		)

		if not WidthOverride then 
			WidthOverride = _ARTG.SV.GetVariable("HMD_Width") or 150
		end 

		local BarHeight = _ARTG.SV:GetVariable("HMD_BarHeight") or 20
		local BarWidth = WidthOverride - 2*Padding

		for i,v in ipairs(HealerManaTable) do 
			v:ClearAllPoints()
			v:Size(BarWidth,BarHeight)
			v:SetPoint("TOPLEFT",HealerManaDisplay,"TOPLEFT",Padding,-(i - 1)*(BarHeight + Padding) - Padding)
		end 
		HealerManaDisplay:Size(WidthOverride,(BarHeight + Padding)*getn(HealerManaTable) + Padding)

		HealerManaDisplay.BarHeight = BarHeight
		HealerManaDisplay.BarWidth = BarWidth
end

function Display:UpdateColors(BarIndex)
		if BarIndex then 
			local r,g,b
			if HealerManaTable[BarIndex].HMB_Offline or HealerManaTable[BarIndex].HMB_Dead then 
				r = 0.35
				g = 0.35
				b = 0.35
			elseif _ARTG.SV.GetVariable("HMD_BarClassColor") and HealerManaTable[BarIndex].HMB_UnitID then 
				local _,G_ClassName = UnitClass(HealerManaTable[BarIndex].HMB_UnitID)
				r,g,b = GetClassColor(G_ClassName)
				r = r * 0.65
				g = g * 0.65
				b = b * 0.65
			else
				r = _ARTG.SV.GetVariable("HMD_BarColorr") 
				g = _ARTG.SV.GetVariable("HMD_BarColorg") 
				b = _ARTG.SV.GetVariable("HMD_BarColorb") 
			end
			r = r or 0.25
			g = g or 0.25
			b = b or 1
			HealerManaTable[BarIndex]:SetBarColor(r,g,b,1)

			local fr = _ARTG.SV.GetVariable("HMD_BarFontColorr") or 1
			local fg = _ARTG.SV.GetVariable("HMD_BarFontColorg") or 0.82
			local fb = _ARTG.SV.GetVariable("HMD_BarFontColorb") or 0

			if HealerManaTable[BarIndex].Text1 then 
				HealerManaTable[BarIndex].Text1:SetTextColor(fr,fg,fb)
			end 
			if HealerManaTable[BarIndex].Text2 then 
				HealerManaTable[BarIndex].Text2:SetTextColor(fr,fg,fb)
			end 
		else 
			_ARTG:FrameBackdropColoring(HealerManaDisplay,_ARTG.SV.GetVariable("HMD_Anchor"),_ARTG.SV.GetVariable("HMD_MatchBackdrop"),_ARTG.SV.GetVariable("HMD_Backdrop"),
				_ARTG.SV.GetVariable("HMB_Backdropr"),_ARTG.SV.GetVariable("HMB_Backdropg"),_ARTG.SV.GetVariable("HMB_Backdropb"),_ARTG.SV.GetVariable("HMB_Backdropa")
			)
	
			for i,v in ipairs(HealerManaTable) do 
				Display:UpdateColors(i)
			end
		end
end

function Display:EditHealerManaBar(Action,GUID,UnitID,GivenIndex)
		if Action == "Clear" then 
			for i,v in ipairs(HealerManaTable) do 
				v:Release()
			end
			table.wipe(HealerManaTable)
			HealerManaDisplay:Hide()
			return nil
		end
		local Index = 0
		if GivenIndex then 
			if HealerManaTable[GivenIndex] and HealerManaTable[GivenIndex].HMB_GUID == GUID then 
				Index = GivenIndex
			else
				return nil
			end
		else
			for i,v in ipairs(HealerManaTable) do 
				if v.HMB_GUID == GUID then 
					Index = i
					break 
				end
			end
		end 
		if Action == "Remove" then 
			 if HealerManaTable[Index] then 
				HealerManaTable[Index]:Release()
				table.remove(HealerManaTable,Index)
				for i = Index,getn(HealerManaTable) do 
					Display:EditHealerManaBar("Update",HealerManaTable[i].HMB_GUID,HealerManaTable[i].HMB_UnitID,i)
				end
				HealerManaDisplay:Size(nil,(HealerManaDisplay.BarHeight + Padding)*getn(HealerManaTable) + Padding)
			 end
		elseif Action == "Add" then
			local UpdateFunctions = false
			if Index == 0 then 
				--print("ADDED",UnitID)
				table.insert(HealerManaTable,Widgets:CreateProgressBar(HealerManaDisplay,true))
				Index = getn(HealerManaTable)
				HealerManaTable[Index]:Size(HealerManaDisplay.BarWidth,HealerManaDisplay.BarHeight)
				HealerManaTable[Index].HMB_UnitID = UnitID
				HealerManaTable[Index].HMB_GUID = GUID
				HealerManaDisplay:Size(nil,(HealerManaDisplay.BarHeight + Padding)*Index + Padding)
				HealerManaTable[Index]:SetText({
					{Text = UnitName(UnitID), HAlign = "LEFT"},
					{Text = "100%",HAlign = "RIGHT", Overlapping = true, DontResize = true}
				})
				Display:UpdateColors(Index)
				Display:EditHealerManaBar("Update",GUID,UnitID,Index)
				UpdateFunctions = true 
			elseif HealerManaTable[Index].HMB_UnitID ~= UnitID then 
				HealerManaTable[Index].HMB_UnitID = UnitID  
				HealerManaTable[Index].Text1:SetText(UnitName(UnitID))      
				UpdateFunctions = true 
			end
			if UpdateFunctions then 
				local MaxPower = UnitPowerMax(HealerManaTable[Index].HMB_UnitID,0)
				if MaxPower == 0 then 
					MaxPower = 1000
				end
				local Power = UnitPower(HealerManaTable[Index].HMB_UnitID,0)
				HealerManaTable[Index]:SetValue(Power/MaxPower)
				if UnitIsDead(HealerManaTable[Index].HMB_UnitID) then 
					HealerManaTable[Index].Text2:SetText(Loc:Translation("DEAD"))
					HealerManaTable[Index].HMB_Dead = true 
					Display:UpdateColors(Index)
				end
				--HMD_FrequentUpdate			
				HealerManaTable[Index]:RegisterUnitEvent("UNIT_FLAGS",HealerManaTable[Index].HMB_UnitID)
				HealerManaTable[Index]:RegisterUnitEvent("UNIT_MAXPOWER",HealerManaTable[Index].HMB_UnitID)
				HealerManaTable[Index]:RegisterUnitEvent("UNIT_POWER_UPDATE",HealerManaTable[Index].HMB_UnitID)
				HealerManaTable[Index]:SetScript("OnEvent",
				function(this,Event,_,PowerType)
					if HealerManaTable[Index] then 
						local ForceUpdate = false
						if UnitIsDead(HealerManaTable[Index].HMB_UnitID) then 
							HealerManaTable[Index].Text2:SetText(Loc:Translation("DEAD"))
							HealerManaTable[Index].HMB_Dead = true 
							Display:UpdateColors(Index)
						elseif HealerManaTable[Index].HMB_Dead or HealerManaTable[Index].HMB_Offline then 
							HealerManaTable[Index].HMB_Offline = nil 
							HealerManaTable[Index].HMB_Dead = nil 
							Display:UpdateColors(Index)
							ForceUpdate = true 
						end 
						if ((Event == "UNIT_MAXPOWER" or Event == "UNIT_POWER_UPDATE" or Event == "UNIT_POWER_FREQUENT") and PowerType == "MANA") or ForceUpdate then 
							local Power = UnitPower(this.HMB_UnitID,0)
							local MaxPower = UnitPowerMax(this.HMB_UnitID,0)
							if Power > 0 and MaxPower > 0 then 
								this:SetValue(Power/MaxPower)
								this.Text2:SetText(floor(Power/MaxPower*100).."%")
							end
						end
					end
				end)
			end
		elseif Action == "Update" then 
			if Index == 1 then 
				HealerManaTable[Index]:SetPoint("TOPLEFT",HealerManaDisplay,"TOPLEFT",Padding,-Padding)
			else
				HealerManaTable[Index]:SetPoint("TOPLEFT",HealerManaTable[Index - 1],"BOTTOMLEFT",0,-Padding)
			end   
			HealerManaTable[Index].Text1:SetText(UnitName(HealerManaTable[Index].HMB_UnitID))
		end
		if getn(HealerManaTable) > 0 and not HealerManaDisplay:IsShown() then 
			if _ARTG:CheckLoadConditions("HealerManaDisplay") then 
				HealerManaDisplay:Show()
			else 
				HealerManaDisplay:Hide()
			end
		elseif getn(HealerManaTable) == 0 then 
			HealerManaDisplay:Hide()
		end
end

local function CheckHealerDisplayCondition(GUID)
	local _,_,_,ZoneID = UnitPosition("player")
	return _ARTG.Data.InspectPlayerData[GUID] and _ARTG.Data.InspectPlayerData[GUID].UnitID and _ARTG.Data.InspectPlayerData[GUID].Role and _ARTG.Data.InspectPlayerData[GUID].Role == "HEALER" and
				(not _ARTG.SV.GetVariable("HMD_MatchZone") or (_ARTG.Data.InspectPlayerData[GUID].Zone == ZoneID)) and
				((not _ARTG.SV.GetVariable("HMD_IgnoreOwn") and GUID == UnitGUID("player")) or GUID ~= UnitGUID("player"))
end

function Display:Refresh(GUID)
		if GUID then
			if CheckHealerDisplayCondition(GUID) then 
				Display:EditHealerManaBar("Add",GUID,_ARTG.Data.InspectPlayerData[GUID].UnitID) 
			else
				Display:EditHealerManaBar("Remove",GUID) 
			end
		else
			Display:EditHealerManaBar("Clear")
			for i,v in pairs(_ARTG.Data.InspectPlayerData) do 
				if CheckHealerDisplayCondition(i) then 
					Display:EditHealerManaBar("Add",i,v.UnitID) 
				end
			end
		end
end 


