local MouseIsOver, insert = MouseIsOver, table.insert;

function _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin:CreateButton(Parent,Borderless)
    local Button = self:CreateFrame(Parent)
    if not Borderless then 
        Button:SetThemedBackdrop()
    end 

    Button:SetText("",nil,"Highlight")

    Button.State = "Normal"
    Button.Focus = false

    Button.SetFocus = function(btn, Focus)
        Button.Focus = Focus
        btn:PresetBorders(btn.State, btn.Focus, Borderless)
    end

    Button.EnterLeave = function(btn, Enter)
        if Enter then
            if btn.State ~= "Pushed" and not btn.Disable and (not btn.ActiveCheck or (btn.ActiveCheck and btn.ActiveCheck())) then
                btn.State = "MouseOver"
                btn:PresetBorders(btn.State, btn.Focus, Borderless)
            end
        else
            btn.State = "Normal"
            btn:PresetBorders(btn.State, btn.Focus, Borderless)
        end
    end

    Button.MouseInteraction = function(btn, Up, Button)
        if Up then
            if not btn.Disable and (not btn.ActiveCheck or (btn.ActiveCheck and btn.ActiveCheck())) and MouseIsOver(btn) then
                btn.State = "MouseOver"
                btn:PresetBorders(btn.State, btn.Focus, Borderless)
                if btn.OnClick then
                    btn:OnClick(Button)
                end
            else
                btn:SetThemedBackdrop("Border")
                btn.State = "Normal"
                btn:PresetBorders(btn.State, btn.Focus, Borderless)
            end
        else
            if not btn.Disable and (not btn.ActiveCheck or (btn.ActiveCheck and btn.ActiveCheck())) then
                btn.State = "Pushed"
                btn:PresetBorders(btn.State, btn.Focus, Borderless)
            end
        end
    end
    Button:MakeInteractable(true);

    Button.CloseButtonTexture = function(btn)
        btn:SetIcon("TexturePath",self:GetIcon("PlusMask"),"Red",1,"Green",0.25,"Blue",0.25,"Rotation",45,"Zoom",0.2);
    end

    return Button
end
