local MouseIsOver, insert = MouseIsOver, table.insert;

function _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin:CreateProgressBar(Parent)
    local Bar = self:CreateFrame(Parent)
    Bar:SetThemedBackdrop()

    Bar.ProgressBarTexture = self:FetchTexture(Bar)
    Bar.ProgressBarTexture:SetPoint("TOPLEFT",self.BorderSize,-self.BorderSize)
    Bar.ProgressBarTexture:SetPoint("BOTTOMLEFT",self.BorderSize,self.BorderSize)

    Bar.Value = 0
    Bar.SetValue = function(this,Ratio)
        if Ratio > 1 then 
            Ratio = 1 
        elseif Ratio <= 0 then 
            this.ProgressBarTexture:Hide()
            return 
        end
        if not this.ProgressBarTexture:IsShown() then 
            this.ProgressBarTexture:Show()
        end
	    this.ProgressBarTexture:SetWidth(Ratio*(this:GetWidth() - 2*self.BorderSize))
        this.Value = Ratio
    end

    Bar.SetBarColor = function(this,r,g,b,a)
        this.ProgressBarTexture:ClearTheme()
        this.ProgressBarTexture:SetVertexColor(r or 1,g or 1,b or 1,a or 1)
    end

    Bar.SetBarColorTheme = function(this,Type)
        self:SetThemedColor(this.ProgressBarTexture,Type)        
    end

    Bar:SizeChanged(function()
        Bar.ProgressBarTexture:SetWidth(Bar.Value*(Bar:GetWidth() - 2*self.BorderSize))
    end)

    self:SetThemedColor(Bar.ProgressBarTexture,"Highlight")

    return Bar
end
