local Widgets = _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin
local insert, ipairs = table.insert, ipairs;

_Avyr_Global_ADDON_Elements_Lib.FontStringParent = _Avyr_Global_ADDON_Elements_Lib.FontStringParent or CreateFrame("Frame")
local function Release(self)
    self.ColorThemeAlignment = nil
    self:SetTextColor(1,0.82,0)
    self:SetParent(_Avyr_Global_ADDON_Elements_Lib.FontStringParent)
    local Font, _, Flags = self:GetFont()
    self:SetFont(Font, 11, nil)
    self:Size(0,0)
    self:SetJustifyH("CENTER")
    self:SetJustifyV("CENTER")
    self:Hide()
	self.IsReleased = true
end

local function SetFontSizeOnly(self,Size)
    local Font, _, Flags = self:GetFont()
    self:SetFont(Font, Size, Flags)
end 

local function SetSize(self, w, h)
    if w then
		self.InternalWidth = w;
    end
    if h then
		self.InternalHeight = h;
    end
    self:SetSize(self.InternalWidth, self.InternalHeight)
end

function _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin:FetchFontString(Parent)
    local String
    for i, v in ipairs(_Avyr_Global_ADDON_Elements_Lib.FontStrings) do
        if v.IsReleased then
            String = v
        end
    end

    if not String then
        String = _Avyr_Global_ADDON_Elements_Lib.FontStringParent:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        local Font, _, Flags = String:GetFont()
        String:SetFont(Font, 11, Flags)
        insert(_Avyr_Global_ADDON_Elements_Lib.FontStrings,String)
        String.Release = Release
        String.SetFontSizeOnly = SetFontSizeOnly
		
		String.Size = SetSize
		String.InternalWidth = 0
		String.InternalHeight = 0
		String.OnSizeChanged = function(self, width, height)
			if width ~= self.InternalWidth then 
				self:SetWidth(self.InternalWidth)
			end 
			if Height ~= self.InternalHeight then 
				self:SetHeight(self.InternalHeight)			
			end
		end
    end
	String.IsReleased = false
    String:ClearAllPoints()
    String:SetParent(Parent or _Avyr_Global_ADDON_Elements_Lib.FontStringParent)
    String:SetText("")
    String:Show()

    return String
end