local Widgets = _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin
local CreateFrame, UIParent, hooksecurefunc, GameTooltip_OnHide, GameTooltip_CycleSecondaryComparedItem = CreateFrame, UIParent, hooksecurefunc, GameTooltip_OnHide, GameTooltip_CycleSecondaryComparedItem
local select, GetItemInfo, GameTooltip_ShowCompareItem, GameTooltip_OnUpdate, type = select, GetItemInfo, GameTooltip_ShowCompareItem, GameTooltip_OnUpdate, type

if not Widgets.Tooltip then 
    Widgets.Tooltip = CreateFrame("GameTooltip", "_Avyr_GUI_ADDON_Widgets_Tooltip", UIParent, "GameTooltipTemplate")
    Widgets.Tooltip.shoppingTooltips = {
        CreateFrame("GameTooltip", "_Avyr_GUI_ADDON_Widgets__ShoppingTooltip1", Widgets.Tooltip, "ShoppingTooltipTemplate"),
        CreateFrame("GameTooltip", "_Avyr_GUI_ADDON_Widgets__ShoppingTooltip2", Widgets.Tooltip, "ShoppingTooltipTemplate")
    };
end 
local Tooltip = Widgets.Tooltip


Tooltip.shoppingTooltips[1].ArrowIcon = Tooltip.shoppingTooltips[1]:CreateTexture(nil, "OVERLAY");
Tooltip.shoppingTooltips[1].ArrowIcon:SetSize(35, 35);
Tooltip.shoppingTooltips[1].ArrowIcon:SetPoint("TOP", Tooltip.shoppingTooltips[1], "TOPLEFT", -5, 0);
Tooltip.shoppingTooltips[1].ArrowIcon:SetTexture("Interface\\BUTTONS\\UI-MicroStream-Green");

Tooltip.shoppingTooltips[2].PlusIcon = Tooltip.shoppingTooltips[2]:CreateTexture(nil, "OVERLAY");
Tooltip.shoppingTooltips[2].PlusIcon:SetSize(25, 25);
Tooltip.shoppingTooltips[2].PlusIcon:SetPoint("CENTER", Tooltip.shoppingTooltips[2], "TOP", 0, 5);
Tooltip.shoppingTooltips[2].PlusIcon:SetTexture("Interface\\PaperDollInfoFrame\\Character-Plus");

local function Backdrop(thisWidgets,self)
    if not self.BackdropTexture then 
        self.BackdropTexture = thisWidgets:FetchTexture(self, "BACKGROUND")
    end
    self.BackdropTexture:SetPoint("BOTTOMLEFT", thisWidgets.BorderSize, thisWidgets.BorderSize)
    self.BackdropTexture:SetPoint("TOPRIGHT", -thisWidgets.BorderSize, -thisWidgets.BorderSize)
    
    self.BackdropTexture:SetColorTexture(thisWidgets.BackdropColor.r, thisWidgets.BackdropColor.g, thisWidgets.BackdropColor.b, thisWidgets.BackdropColor.a)

    if not self.BorderL then 
        self.BorderL = thisWidgets:FetchTexture(self, "BORDER")
        self.BorderL:SetPoint("TOPLEFT")
        self.BorderL:SetPoint("BOTTOMLEFT")
    end
    self.BorderL:SetWidth(thisWidgets.BorderSize)
    self.BorderL:SetColorTexture(thisWidgets.BorderColor.r, thisWidgets.BorderColor.g, thisWidgets.BorderColor.b, thisWidgets.BorderColor.a)

    if not self.BorderR then 
        self.BorderR = thisWidgets:FetchTexture(self, "BORDER")
        self.BorderR:SetPoint("TOPRIGHT")
        self.BorderR:SetPoint("BOTTOMRIGHT")
    end
    self.BorderR:SetWidth(thisWidgets.BorderSize)
    self.BorderR:SetColorTexture(thisWidgets.BorderColor.r, thisWidgets.BorderColor.g, thisWidgets.BorderColor.b, thisWidgets.BorderColor.a)

    if not self.BorderT then 
        self.BorderT = thisWidgets:FetchTexture(self, "BORDER")
        self.BorderT:SetPoint("TOPLEFT", self.BorderL, "TOPRIGHT")
        self.BorderT:SetPoint("TOPRIGHT", self.BorderR, "TOPLEFT")
    end
    self.BorderT:SetHeight(thisWidgets.BorderSize)
    self.BorderT:SetColorTexture(thisWidgets.BorderColor.r, thisWidgets.BorderColor.g, thisWidgets.BorderColor.b, thisWidgets.BorderColor.a)

    if not self.BorderB then 
        self.BorderB = thisWidgets:FetchTexture(self, "BORDER")
        self.BorderB:SetPoint("BOTTOMLEFT", self.BorderL, "BOTTOMRIGHT")
        self.BorderB:SetPoint("BOTTOMRIGHT", self.BorderR, "BOTTOMLEFT")
    end
    self.BorderB:SetHeight(thisWidgets.BorderSize)
    self.BorderB:SetColorTexture(thisWidgets.BorderColor.r, thisWidgets.BorderColor.g, thisWidgets.BorderColor.b, thisWidgets.BorderColor.a)
--[[
    hooksecurefunc(self, "SetBackdrop", function(self, Table)
        if type(Table) ~= "nil" then
            self:SetBackdrop(nil);
        end
    end)
    self:SetBackdrop(nil);]]
end


function Widgets:SetTooltip(Parent,Text,xOffset,yOffset,Special)
    if type(Text) == "nil" then 
        return Tooltip:Hide()
    end 

    local thisWidgets = self
    if Parent.self then 
        thisWidgets = Parent.self
    end 

    Backdrop(thisWidgets,Tooltip);
    Backdrop(thisWidgets,Tooltip.shoppingTooltips[1]);
    Backdrop(thisWidgets,Tooltip.shoppingTooltips[2]);

    xOffset = xOffset or 0;
    yOffset = yOffset or 0;
    local Midx, Midy = UIParent:GetCenter();
    local Parentx, Parenty = Parent:GetCenter();
    local Point = "ANCHOR_BOTTOMRIGHT"
    if Midy < Parenty then --top
        if Midx < Parentx then --parent top right
            Point = "ANCHOR_BOTTOMLEFT";
            xOffset = -xOffset;
        else --parent top left
            --no change (default anchor)
        end
        yOffset = -yOffset;
    else --bottom
        if Midx < Parentx then --parent bottom right
            Point = "ANCHOR_LEFT";
            xOffset = -xOffset;
        else --parent bottom left
            Point = "ANCHOR_RIGHT";
        end
    end
    Tooltip:SetOwner(Parent, Point, xOffset, yOffset)
    if Text then
        if Special then
            Tooltip[Text](Tooltip,unpack(Special))
        else
            Tooltip:SetText(Text, 1, 1, 1, nil, true);
        end
    end
end

Tooltip:SetScript("OnHide", function(self)
    GameTooltip_OnHide(self);
    self.shoppingTooltips[1]:Hide();
    self.shoppingTooltips[2]:Hide();
end)

local Vert = false;
local function AdjustCompareAnchors()
    Tooltip.shoppingTooltips[1]:ClearAllPoints();
    Tooltip.shoppingTooltips[2]:ClearAllPoints();
    local _, CompreItem = Tooltip:GetItem();
    local _, CurrentCompreItem = Tooltip.shoppingTooltips[1]:GetItem();
    local TooltipAnchorType = 1;
    --1 - both current items next to each other (rings, trinkets)
    --2 - offhand item below reward (1 hand weapons reward or offhand weapon when 2h equipt)
    --3 - offhand below current equipt (2 hand weapons reward and 1 hand equipt)
    if CompreItem and CurrentCompreItem then
        local ItemLocation = select(9, GetItemInfo(CompreItem));
        local CurrentItemLocation = select(9, GetItemInfo(CurrentCompreItem));
        if ItemLocation == "INVTYPE_TRINKET" or ItemLocation == "INVTYPE_FINGER" then
            TooltipAnchorType = 1;
        elseif ItemLocation:find("2") or ItemLocation:find("RANGED") then
            TooltipAnchorType = 3;
        elseif (ItemLocation:find("WEAPON") or ItemLocation:find("HOLDABLE") or ItemLocation:find("OFFHAND") or ItemLocation:find("SHIELD"))
                and (CurrentItemLocation:find("2") or CurrentItemLocation:find("RANGED")) then
            TooltipAnchorType = 2;
        end
    end
    if Tooltip.shoppingTooltips[2]:IsShown() and Vert then
        Tooltip.shoppingTooltips[2]:SetPoint("TOPLEFT", Tooltip, "TOPRIGHT", 10, 0);
        Tooltip.shoppingTooltips[1]:SetPoint("TOPLEFT", Tooltip.shoppingTooltips[2], "TOPRIGHT", 10, 0);
    else
        Tooltip.shoppingTooltips[1]:SetPoint("TOPLEFT", Tooltip, "TOPRIGHT", 10, 0);
        if TooltipAnchorType == 1 then
            Tooltip.shoppingTooltips[2]:SetPoint("TOPLEFT", Tooltip.shoppingTooltips[1], "TOPRIGHT", 10, 0);
            Tooltip.shoppingTooltips[2].PlusIcon:Hide();
        elseif TooltipAnchorType == 3 then
            Tooltip.shoppingTooltips[2]:SetPoint("TOP", Tooltip.shoppingTooltips[1], "BOTTOM", 0, -10);
            Tooltip.shoppingTooltips[2].PlusIcon:Show();
        else
            Tooltip.shoppingTooltips[2]:SetPoint("TOP", Tooltip, "BOTTOM", 0, -10);
            Tooltip.shoppingTooltips[2].PlusIcon:Show();
        end
    end
end

Tooltip:SetScript("OnTooltipSetItem", function(self)
    if not self:IsEquippedItem() then
        GameTooltip_ShowCompareItem(self);
        AdjustCompareAnchors();
        self.shoppingTooltips[1].ArrowIcon:SetRotation(1.5707963267948966192313216916398);
    else
        self.shoppingTooltips[1]:Hide();
        self.shoppingTooltips[2]:Hide();
    end
end)

Tooltip:SetScript("OnUpdate", GameTooltip_OnUpdate)

local function TooltipSizeChangedScript(self)
    if Tooltip.shoppingTooltips[1]:IsShown() then
        local yOffset = 17.5
        if Vert then
            if Tooltip.shoppingTooltips[2]:GetHeight() > Tooltip.shoppingTooltips[1]:GetHeight() then
                yOffset = Tooltip.shoppingTooltips[1]:GetHeight() / 2
            else
                yOffset = Tooltip.shoppingTooltips[2]:GetHeight() / 2
            end
        else
            if Tooltip:GetHeight() > Tooltip.shoppingTooltips[1]:GetHeight() then
                yOffset = Tooltip.shoppingTooltips[1]:GetHeight() / 2
            else
                yOffset = Tooltip:GetHeight() / 2
            end
        end
        yOffset = Tooltip.shoppingTooltips[1].ArrowIcon:GetHeight() / 2 - yOffset
        Tooltip.shoppingTooltips[1].ArrowIcon:SetPoint("TOP", Tooltip.shoppingTooltips[1], "TOPLEFT", -5, yOffset)
    end
    if Tooltip.shoppingTooltips[2]:IsShown() then
        Tooltip.shoppingTooltips[2].PlusIcon:ClearAllPoints();
        if Vert then
            local yOffset2 = 12.5
            if Tooltip:GetHeight() > Tooltip.shoppingTooltips[2]:GetHeight() then
                yOffset2 = Tooltip.shoppingTooltips[2]:GetHeight() / 2
            else
                yOffset2 = Tooltip:GetHeight() / 2
            end
            yOffset2 = Tooltip.shoppingTooltips[2].PlusIcon:GetHeight() / 2 - yOffset2
            Tooltip.shoppingTooltips[2].PlusIcon:SetPoint("TOP", Tooltip.shoppingTooltips[2], "TOPLEFT", -5, yOffset2)
        else
            Tooltip.shoppingTooltips[2].PlusIcon:SetPoint("CENTER", Tooltip.shoppingTooltips[2], "TOP", 0, 5)
        end
    end
end

Tooltip:SetScript("OnSizeChanged", TooltipSizeChangedScript)
Tooltip.shoppingTooltips[1]:SetScript("OnSizeChanged", TooltipSizeChangedScript)
Tooltip.shoppingTooltips[2]:SetScript("OnSizeChanged", TooltipSizeChangedScript)

--Hook to cyclecompare to use blizz binding
hooksecurefunc("GameTooltip_CycleSecondaryComparedItem", function(self, ...)
    if self and type(self.GetName) == "function" and self:GetName() ~= "_Avyr_GUI_Widgets_Tooltip" and Tooltip:IsShown() then
        GameTooltip_CycleSecondaryComparedItem(Tooltip);
        AdjustCompareAnchors();
    end
end)
